Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.net
Class DatagramSocket

    java.lang.Object
      |
      +--java.net.DatagramSocket

Direct Known Subclasses:
  MulticastSocket

public class DatagramSocket
extends Object

This class represents a socket for sending and receiving datagram packets.

A datagram socket is the sending or receiving point for a packet delivery service. Each packet sent or received on a datagram socket is individually addressed and routed. Multiple packets sent from one machine to another may be routed differently, and may arrive in any order.

UDP broadcasts sends and receives are always enabled on a DatagramSocket.

Since:
  JDK1.0
See Also:
  `DatagramPacket`

Constructor Summary
`DatagramSocket()` Constructs a datagram socket and binds it to any available port on the local host machine.
`DatagramSocket(int port)` Constructs a datagram socket and binds it to the specified port on the local host machine.
`DatagramSocket(int port, InetAddress laddr)` Creates a datagram socket, bound to the specified local address.

Method Summary
`void` | `close()` Closes this datagram socket.
`void` | `connect(InetAddress address, int port)` Connects the socket to a remote address for this socket.
`void` | `disconnect()` Disconnects the socket.
`InetAddress` | `getInetAddress()` Returns the address to which this socket is connected.
`InetAddress` | `getLocalAddress()` Gets the local address to which the socket is bound.
`int` | `getLocalPort()` Returns the port number on the local host to which this socket is bound.
`int` | `getPort()` Returns the port for this socket.
`int` | `getReceiveBufferSize()` Get value of the SO_RCVBUF option for this `DatagramSocket`, that is the buffer size used by the platform for input on this `DatagramSocket`.
`int` | `getSendBufferSize()` Get value of the SO_SNDBUF option for this `DatagramSocket`, that is the buffer size used by the platform for output on this `DatagramSocket`.
`int` | `getSoTimeout()` Retrive setting for SO_TIMEOUT.
`void` | `receive(DatagramPacket p)` Receives a datagram packet from this socket.
`void` | `send(DatagramPacket p)` Sends a datagram packet from this socket.
`static void` | `setDatagramSocketImplFactory(DatagramSocketImplFactory fac)` Sets the datagram socket implementation factory for the application.
`void` | `setReceiveBufferSize(int size)` Sets the SO_RCVBUF option to the specified value for this `DatagramSocket`.
`void` | `setSendBufferSize(int size)` Sets the SO_SNDBUF option to the specified value for this `DatagramSocket`.
`void` | `setSoTimeout(int timeout)` Enable/disable SO_TIMEOUT with the specified timeout, in milliseconds.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### DatagramSocket

    public DatagramSocket()
                   throws SocketException

  Constructs a datagram socket and binds it to any available port on the local host machine.

  If there is a security manager, its `checkListen` method is first called with 0 as its argument to ensure the operation is allowed. This could result in a SecurityException.

  Throws:
    `SocketException` - if the socket could not be opened, or the socket could not bind to the specified local port.
    `SecurityException` - if a security manager exists and its `checkListen` method doesn't allow the operation.
  See Also:
    `SecurityManager.checkListen(int)`

### DatagramSocket

    public DatagramSocket(int port)
                   throws SocketException

  Constructs a datagram socket and binds it to the specified port on the local host machine.

  If there is a security manager, its `checkListen` method is first called with the `port` argument as its argument to ensure the operation is allowed. This could result in a SecurityException.

  Parameters:
    `port` - port to use.
  Throws:
    `SocketException` - if the socket could not be opened, or the socket could not bind to the specified local port.
    `SecurityException` - if a security manager exists and its `checkListen` method doesn't allow the operation.
  See Also:
    `SecurityManager.checkListen(int)`

### DatagramSocket

    public DatagramSocket(int port,
                          InetAddress laddr)
                   throws SocketException

  Creates a datagram socket, bound to the specified local address. The local port must be between 0 and 65535 inclusive.

  If there is a security manager, its `checkListen` method is first called with the `port` argument as its argument to ensure the operation is allowed. This could result in a SecurityException.

  Parameters:
    `port` - local port to use
    `laddr` - local address to bind
  Throws:
    `SocketException` - if the socket could not be opened, or the socket could not bind to the specified local port.
    `SecurityException` - if a security manager exists and its `checkListen` method doesn't allow the operation.
  Since:
    JDK1.1
  See Also:
    `SecurityManager.checkListen(int)`

Method Detail

### connect

    public void connect(InetAddress address,
                        int port)

  Connects the socket to a remote address for this socket. When a socket is connected to a remote address, packets may only be sent to or received from that address. By default a datagram socket is not connected.

  A caller's permission to send and receive datagrams to a given host and port are checked at connect time. When a socket is connected, receive and send will not perform any security checks on incoming and outgoing packets, other than matching the packet's and the socket's address and port. On a send operation, if the packet's address is set and the packet's address and the socket's address do not match, an IllegalArgumentException will be thrown. A socket connected to a multicast address may only be used to send packets.

  Parameters:
    `address` - the remote address for the socket
    `port` - the remote port for the socket.
  Throws:
    `IllegalArgumentException` - if the address is invalid or the port is out of range.
    `SecurityException` - if the caller is not allowed to send datagrams to and receive datagrams from the address and port.
  See Also:
    `disconnect()`, `send(java.net.DatagramPacket)`, `receive(java.net.DatagramPacket)`

### disconnect

    public void disconnect()

  Disconnects the socket. This does nothing if the socket is not connected.
  See Also:
    `connect(java.net.InetAddress, int)`

### getInetAddress

    public InetAddress getInetAddress()

  Returns the address to which this socket is connected. Returns null if the socket is not connected.
  Returns:
    the address to which this socket is connected.

### getPort

    public int getPort()

  Returns the port for this socket. Returns -1 if the socket is not connected.
  Returns:
    the port to which this socket is connected.

### send

    public void send(DatagramPacket p)
              throws IOException

  Sends a datagram packet from this socket. The `DatagramPacket` includes information indicating the data to be sent, its length, the IP address of the remote host, and the port number on the remote host.

  If there is a security manager, and the socket is not currently connected to a remote address, this method first performs some security checks. First, if `p.getAddress().isMulticastAddress()` is true, this method calls the security manager's `checkMulticast` method with `p.getAddress()` as its argument. If the evaluation of that expression is false, this method instead calls the security manager's `checkConnect` method with arguments `p.getAddress().getHostAddress()` and `p.getPort()`. Each call to a security manager method could result in a SecurityException if the operation is not allowed.

  Parameters:
    `p` - the `DatagramPacket` to be sent.
  Throws:
    `IOException` - if an I/O error occurs.
    `SecurityException` - if a security manager exists and its `checkMulticast` or `checkConnect` method doesn't allow the send.
  See Also:
    `DatagramPacket`, `SecurityManager.checkMulticast(InetAddress)`, `SecurityManager.checkConnect(java.lang.String, int)`

### receive

    public void receive(DatagramPacket p)
                 throws IOException

  Receives a datagram packet from this socket. When this method returns, the `DatagramPacket`'s buffer is filled with the data received. The datagram packet also contains the sender's IP address, and the port number on the sender's machine.

  This method blocks until a datagram is received. The `length` field of the datagram packet object contains the length of the received message. If the message is longer than the packet's length, the message is truncated.

  If there is a security manager, a packet cannot be received if the security manager's `checkAccept` method does not allow it.

  Parameters:
    `p` - the `DatagramPacket` into which to place the incoming data.
  Throws:
    `IOException` - if an I/O error occurs.
  See Also:
    `DatagramPacket`, `DatagramSocket`

### getLocalAddress

    public InetAddress getLocalAddress()

  Gets the local address to which the socket is bound.

  If there is a security manager, its `checkConnect` method is first called with the host address and `-1` as its arguments to see if the operation is allowed.

  Returns:
    an `InetAddress` representing the local address to which the socket is bound
  Throws:
    `SecurityException` - if a security manager exists and its `checkConnect` method doesn't allow the operation.
  Since:
    1.1
  See Also:
    `SecurityManager.checkConnect(java.lang.String, int)`

### getLocalPort

    public int getLocalPort()

  Returns the port number on the local host to which this socket is bound.
  Returns:
    the port number on the local host to which this socket is bound.

### setSoTimeout

    public void setSoTimeout(int timeout)
                      throws SocketException

  Enable/disable SO_TIMEOUT with the specified timeout, in milliseconds. With this option set to a non-zero timeout, a call to receive() for this DatagramSocket will block for only this amount of time. If the timeout expires, a java.io.InterruptedIOException is raised, though the ServerSocket is still valid. The option must be enabled prior to entering the blocking operation to have effect. The timeout must be > 0. A timeout of zero is interpreted as an infinite timeout.
  Parameters:
    `timeout` - the specified timeout in milliseconds.
  Throws:
    `SocketException` - if there is an error in the underlying protocol, such as a TCP error.
  Since:
    JDK1.1
  See Also:
    `getSoTimeout()`

### getSoTimeout

    public int getSoTimeout()
                     throws SocketException

  Retrive setting for SO_TIMEOUT. 0 returns implies that the option is disabled (i.e., timeout of infinity).
  Returns:
    the setting for SO_TIMEOUT
  Throws:
    `SocketException` - if there is an error in the underlying protocol, such as a TCP error.
  Since:
    JDK1.1
  See Also:
    `setSoTimeout(int)`

### setSendBufferSize

    public void setSendBufferSize(int size)
                           throws SocketException

  Sets the SO_SNDBUF option to the specified value for this `DatagramSocket`. The SO_SNDBUF option is used by the platform's networking code as a hint for the size to set the underlying network I/O buffers.

  Increasing buffer size can increase the performance of network I/O for high-volume connection, while decreasing it can help reduce the backlog of incoming data. For UDP, this sets the maximum size of a packet that may be sent on this socket.

  Because SO_SNDBUF is a hint, applications that want to verify what size the buffers were set to should call `getSendBufferSize()`.

  Parameters:
    `size` - the size to which to set the send buffer size. This value must be greater than 0.
  Throws:
    ``SocketException`` - if there is an error in the underlying protocol, such as a TCP error.
    ``IllegalArgumentException`` - if the value is 0 or is negative.
  See Also:
    `getSendBufferSize()`

### getSendBufferSize

    public int getSendBufferSize()
                          throws SocketException

  Get value of the SO_SNDBUF option for this `DatagramSocket`, that is the buffer size used by the platform for output on this `DatagramSocket`.
  Returns:
    the value of the SO_SNDBUF option for this `DatagramSocket`
  Throws:
    ``SocketException`` - if there is an error in the underlying protocol, such as a TCP error.
  See Also:
    `setSendBufferSize(int)`

### setReceiveBufferSize

    public void setReceiveBufferSize(int size)
                              throws SocketException

  Sets the SO_RCVBUF option to the specified value for this `DatagramSocket`. The SO_RCVBUF option is used by the platform's networking code as a hint for the size to set the underlying network I/O buffers.

  Increasing buffer size can increase the performance of network I/O for high-volume connection, while decreasing it can help reduce the backlog of incoming data. For UDP, this sets the maximum size of a packet that may be sent on this `DatagramSocket`.

  Because SO_RCVBUF is a hint, applications that want to verify what size the buffers were set to should call `getReceiveBufferSize()`.

  Parameters:
    `size` - the size to which to set the receive buffer size. This value must be greater than 0.
  Throws:
    ``SocketException`` - if there is an error in the underlying protocol, such as a TCP error.
    `IllegalArgumentException` - if the value is 0 or is negative.
  See Also:
    `getReceiveBufferSize()`

### getReceiveBufferSize

    public int getReceiveBufferSize()
                             throws SocketException

  Get value of the SO_RCVBUF option for this `DatagramSocket`, that is the buffer size used by the platform for input on this `DatagramSocket`.
  Returns:
    the value of the SO_RCVBUF option for this `DatagramSocket`
  Throws:
    `SocketException` - if there is an error in the underlying protocol, such as a TCP error.
  See Also:
    `setReceiveBufferSize(int)`

### close

    public void close()

  Closes this datagram socket.

### setDatagramSocketImplFactory

    public static void setDatagramSocketImplFactory(DatagramSocketImplFactory fac)
                                             throws IOException

  Sets the datagram socket implementation factory for the application. The factory can be specified only once.

  When an application creates a new datagram socket, the socket implementation factory's `createDatagramSocketImpl` method is called to create the actual datagram socket implementation.

  If there is a security manager, this method first calls the security manager's `checkSetFactory` method to ensure the operation is allowed. This could result in a SecurityException.

  Parameters:
    `fac` - the desired factory.
  Throws:
    `IOException` - if an I/O error occurs when setting the datagram socket factory.
    `SocketException` - if the factory is already defined.
    `SecurityException` - if a security manager exists and its `checkSetFactory` method doesn't allow the operation.
  See Also:
    `DatagramSocketImplFactory.createDatagramSocketImpl()`, `SecurityManager.checkSetFactory()`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2001 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.